import Game from "./game.js";
import End  from "./end.js";
import { sleep } from "./math.js";

let canvas = document.getElementById('gameScreen');
let ctx = canvas.getContext("2d");

const GAME_WIDTH = canvas.width;
const GAME_HEIGHT = canvas.height;
const END_GAME_FREEZE_T = 2000;

let game = new Game(GAME_WIDTH, GAME_HEIGHT);
let end  = new End(GAME_WIDTH, GAME_HEIGHT);


function mainLoop( ){


  ctx.fillStyle = "#272822";
  ctx.fillRect(0,0,GAME_WIDTH, GAME_HEIGHT);

  // gaming part.
  if ( game.timeLeft > 0 ) {
    game.update();
    game.draw(ctx);
  }

  // transitionPart.
  else if (game.timeLeft == 0){

    end._score = game.score; // setter.
    game.draw(ctx);

    sleep( END_GAME_FREEZE_T ).then(() => {

      // clear the canvas from button and table // if to do it once.
       if (document.getElementById("FIRST")){

         let crTable = document.getElementById('crTab');
         crTable.rows[1].cells[2].innerHTML = 0;
         crTable.rows[2].cells[2].innerHTML = 0;
         crTable.rows[3].cells[2].innerHTML = 0;
         crTable.rows[4].cells[2].innerHTML = 0;
         crTable.rows[5].cells[2].innerHTML = 0;

         crTable.disabled  = true;
         crTable.style.visibility = "hidden";

         removeElement("FIRST");
         removeElement("SECOND");
         removeElement("THIRD");
         removeElement("FOUR");
         removeElement("FIVE");

      }

      game.timeLeft = -1 // to go to the end menu part.

    });

  }

  // end menu part.
  else {
      if ( end.update() == "restart") {
        game = new Game(GAME_WIDTH, GAME_HEIGHT);
        end  = new End(GAME_WIDTH, GAME_HEIGHT);
        document.getElementById("crTab").disabled  = false;
        document.getElementById("crTab").style.visibility = "visible";
      } else {
        end.drawEndMenu(ctx);
        end.drawLeaderBoard(ctx);
      }
  }

  requestAnimationFrame(mainLoop);

}

requestAnimationFrame(mainLoop);


function removeElement(id) {
    var elem = document.getElementById(id);
    return elem.parentNode.removeChild(elem);
}
// console.log("here");
